#include <epplet.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <signal.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "xmmsctrl.h"

#define TIME 0.1

int vol = 100;
int pos = 0;
int number = 0;
int zero = 0;
char **paths;
gint save_volume;
gint save_place;
gint xmms_session = 0;
char *xmms_cmd = "xmms &";
gboolean xmms_running = FALSE;
int main_window = 0;

Epplet_gadget vol_label;
Epplet_gadget pos_label;
Epplet_gadget vol_slider;
Epplet_gadget pos_slider;
Epplet_gadget back_btn;
Epplet_gadget play_btn;
Epplet_gadget pause_btn;
Epplet_gadget stop_btn;
Epplet_gadget next_btn;
Epplet_gadget eject_btn;
Epplet_gadget configure_btn;
Epplet_gadget help_btn;
Epplet_gadget exit_btn;
Epplet_gadget start_btn;
Epplet_gadget show_playlist_btn;
Epplet_gadget show_eq_btn;
Epplet_gadget show_main_btn;

static void check_vol_pos (void *data);

void not_running()
{
	if (xmms_running)
	{
		xmms_running = FALSE;
		Epplet_gadget_hide (vol_label);
		Epplet_gadget_hide (pos_label);
		Epplet_gadget_hide (vol_slider);
		Epplet_gadget_hide (pos_slider);
		Epplet_gadget_hide (back_btn);
		Epplet_gadget_hide (play_btn);
		Epplet_gadget_hide (pause_btn);
		Epplet_gadget_hide (stop_btn);
		Epplet_gadget_hide (next_btn);
		Epplet_gadget_hide (eject_btn);
		Epplet_gadget_hide (configure_btn);
		Epplet_gadget_hide (help_btn);
		Epplet_gadget_hide (exit_btn);
		Epplet_gadget_hide (show_playlist_btn);
		Epplet_gadget_hide (show_eq_btn);
		Epplet_gadget_hide (show_main_btn);
	}
	Epplet_gadget_show (start_btn);
	
	Esync();
	
	Epplet_timer (check_vol_pos, NULL, TIME, "TIMER");
}

void is_running()
{	
	if (!xmms_running)
	{
		xmms_running = TRUE;
		Epplet_gadget_hide (start_btn);
	}
	
	Epplet_gadget_show (vol_label);
	Epplet_gadget_show (pos_label);
	Epplet_gadget_show (vol_slider);
	Epplet_gadget_show (pos_slider);
	Epplet_gadget_show (back_btn);
	Epplet_gadget_show (play_btn);
	Epplet_gadget_show (pause_btn);
	Epplet_gadget_show (stop_btn);
	Epplet_gadget_show (next_btn);
	Epplet_gadget_show (eject_btn);
	Epplet_gadget_show (configure_btn);
	Epplet_gadget_show (help_btn);
	Epplet_gadget_show (exit_btn);
	Epplet_gadget_show (show_playlist_btn);
	Epplet_gadget_show (show_eq_btn);
	Epplet_gadget_show (show_main_btn);
		
	Esync();

	xmms_remote_main_win_toggle (xmms_session, FALSE);
	
	Epplet_timer (check_vol_pos, NULL, TIME, "TIMER");
}

static void check_vol_pos (void *data)
{
	gint volume;
	gint len;
	gint place;
	gboolean need_to_sync = FALSE;
	gboolean running;
	
	running = xmms_remote_is_running (xmms_session);
	
	if (running)
	{
		if (!xmms_running)
		{	
			is_running();	
		}

		volume = xmms_remote_get_main_volume (xmms_session);
		len = xmms_remote_get_playlist_time (xmms_session, xmms_remote_get_playlist_pos(xmms_session));
		place = ((int)(((float)xmms_remote_get_output_time (xmms_session) / (float)len) * 100.0));

		if (volume != save_volume);
		{
			vol = 100 - volume;
			save_volume = volume;
			Epplet_gadget_data_changed (vol_slider);
		}

		if (place != save_place);
		{
			pos = 100 - place;
			save_place = place;
			Epplet_gadget_data_changed (pos_slider);
		}
	}
	else
	{
		if (xmms_running)
		{
			not_running();
		}
		need_to_sync = TRUE;
	}

	if (need_to_sync)
	{
		Epplet_timer(check_vol_pos, NULL, 10*TIME, "TIMER");
	}
	else 
	{
		Epplet_timer(check_vol_pos, NULL, TIME, "TIMER");
	}
}

static void vol_slider_cb (void *data)
{
	save_volume = 100 - vol;
	xmms_remote_set_main_volume (xmms_session, save_volume);
}

static void pos_slider_cb (void *data)
{
	int len = xmms_remote_get_playlist_time (xmms_session, xmms_remote_get_playlist_pos (xmms_session));
	save_place = 100 - pos;
	
	xmms_remote_jump_to_time (xmms_session, (int)(((float)save_place * (float)len) / 100.0));
	
}

static void back_cb (void *data)
{
	xmms_remote_playlist_prev (xmms_session);
}

static void play_cb (void *data)
{
	xmms_remote_play (xmms_session);
}

static void pause_cb (void *data)
{
	xmms_remote_pause (xmms_session);
}

static void stop_cb (void *data)
{
	xmms_remote_stop (xmms_session);
}

static void next_cb (void *data)
{
	xmms_remote_playlist_next (xmms_session);
}

static void eject_cb (void *data)
{
	xmms_remote_eject (xmms_session);
}

static void configure_cb (void *data)
{
	xmms_remote_show_prefs_box (xmms_session);
}

static void help_cb (void *data)
{
	data = NULL;
   	Epplet_show_about ("enxamp");
}

static void main_cb (void *data)
{
	if (main_window == 0)
	{
		xmms_remote_main_win_toggle (xmms_session, TRUE);
		main_window = 1;
	}
	else
	{
		xmms_remote_main_win_toggle (xmms_session, FALSE);
		main_window = 0;
	}
}

static void eq_cb (void *data)
{
	xmms_remote_eq_win_toggle (xmms_session, TRUE);
}

static void playlist_cb (void *data)
{
	xmms_remote_pl_win_toggle (xmms_session, TRUE);
}

static void start_cb (void *data)
{
	system (xmms_cmd);
	xmms_remote_main_win_toggle (xmms_session, FALSE);
}

static void close_cb (void *data)
{
  	Epplet_unremember();
   	data = NULL;
   	exit(0);
}

int main (int argc, char **argv)
{
	gboolean xmms_running = 0;
	
	char *temp;
	gchar *real_name;
	int t;
	int varsize;
	int index = 0;
	char *username;
	
	Epplet_Init ("enxamp", "0.01", "Enlightenment XMMS remote controller", 4, 4, argc, argv, 0);

	vol = 100;
	pos = 0;
	
	vol_label = Epplet_create_label (7, 4, "V", 0);	
	pos_label = Epplet_create_label (16, 4, "P", 0);	
	vol_slider = Epplet_create_vslider (6, 12, 50, 0, 100, 1, 10, &vol, vol_slider_cb, NULL);
	pos_slider = Epplet_create_vslider (15, 12, 50, 0, 100, 1, 10, &pos, pos_slider_cb, NULL);	
	
	back_btn = Epplet_create_button (NULL, NULL, 24, 50, 12, 12, "PREVIOUS", 0, NULL, back_cb, NULL);	
	play_btn = Epplet_create_button (NULL, NULL, 36, 50, 12, 12, "PLAY", 0, NULL, play_cb, NULL);	
	next_btn = Epplet_create_button (NULL, NULL, 48, 50, 12, 12, "NEXT", 0, NULL, next_cb, NULL);	
	
	pause_btn = Epplet_create_button (NULL, NULL, 24, 38, 12, 12, "PAUSE", 0, NULL, pause_cb, NULL);	
	stop_btn = Epplet_create_button (NULL, NULL, 36, 38, 12, 12, "STOP", 0, NULL, stop_cb, NULL);	
	eject_btn = Epplet_create_button (NULL, NULL, 48, 38, 12, 12, "EJECT", 0, NULL, eject_cb, NULL);
		
	configure_btn = Epplet_create_button (NULL, NULL, 24, 10, 12, 12, "CONFIGURE", 0, NULL, configure_cb, NULL);	
	help_btn = Epplet_create_button (NULL, NULL, 36, 10, 12, 12, "HELP", 0, NULL, help_cb, NULL);	
	exit_btn = Epplet_create_button (NULL, NULL, 48, 10, 12, 12, "CLOSE", 0, NULL, close_cb, NULL);

	show_main_btn = Epplet_create_button ("m", NULL, 24, 24, 12, 12, NULL, 0, NULL, main_cb, NULL);
	show_eq_btn = Epplet_create_button ("eq", NULL, 36, 24, 12, 12, NULL, 0, NULL, eq_cb, NULL);
	show_playlist_btn = Epplet_create_button ("pl", NULL, 48, 24, 12, 12, NULL, 0, NULL, playlist_cb, NULL);
	
	start_btn = Epplet_create_button ("Start Xmms", NULL, 6, 6, 52, 52, NULL, 0, NULL, start_cb, NULL);

	xmms_running = xmms_remote_is_running (xmms_session);

	if (xmms_running)
	{
		is_running();
		vol = xmms_remote_get_main_volume(xmms_session);
		Epplet_gadget_data_changed (vol_slider);
	}
	else
	{
		not_running();
	}

	Epplet_show();
	Epplet_Loop();
	
	return 0;
}
